diff --git a/ChangeLog b/ChangeLog
index 2d9af44..1ebb9cd 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,39 @@
+2019-05-31  Mike Crowe  <mac@mcrowe.com>
+
+	nptl: Rename lll_timedlock to lll_clocklock and add clockid
+	parameter to indicate the clock that the abstime parameter should
+	be measured against in preparation for adding
+	pthread_mutex_clocklock.
+
+	* sysdeps/nptl/lowlevellock.h (lll_clocklock): Rename from
+	lll_timedlock and add clockid parameter. (__lll_clocklock): Rename
+	from __lll_timedlock and add clockid parameter.
+
+	* nptl/lll_timedlock_wait.c (__lll_clocklock): Rename from
+	__lll_timedlock and add clockid parameter. Use __clock_gettime
+	rather than __gettimeofday so that clockid can be used. This means
+	that conversion from struct timeval is no longer required.
+
+	* nptl/pthread_mutex_timedlock.c (lll_clocklock_elision): Rename
+	from lll_timedlock_elision, add clockid parameter and use
+	meaningful names for other parameters. (__pthread_mutex_timedlock):
+	Pass CLOCK_REALTIME where necessary to lll_clocklock and
+	lll_clocklock_elision.
+
+	* sysdeps/unix/sysv/linux/powerpc/lowlevellock.h
+	(lll_clocklock_elision): Rename from lll_timedlock_elision and add
+	clockid parameter. (__lll_clocklock_elision): Rename from
+	__lll_timedlock_elision and add clockid parameter.
+	* sysdeps/unix/sysv/linux/s390/lowlevellock.h: Likewise.
+	* sysdeps/unix/sysv/linux/x86/lowlevellock.h: Likewise.
+
+	* sysdeps/unix/sysv/linux/powerpc/elision-timed.c
+	(__lll_lock_elision): Call __lll_clocklock_elision rather than
+	__lll_timedlock_elision. (EXTRAARG): Add clockid parameter.
+	(LLL_LOCK): Likewise.
+	* sysdeps/unix/sysv/linux/s390/elision-timed.c: Likewise.
+	* sysdeps/unix/sysv/linux/x86/elision-timed.c: Likewise.
+
 2019-05-30  Mike Crowe  <mac@mcrowe.com>
 
 	* nptl/eintr.c: Use libsupport.
diff --git a/nptl/lll_timedlock_wait.c b/nptl/lll_timedlock_wait.c
index 1f489ed..4f97234 100644
--- a/nptl/lll_timedlock_wait.c
+++ b/nptl/lll_timedlock_wait.c
@@ -24,7 +24,8 @@
 
 
 int
-__lll_timedlock_wait (int *futex, const struct timespec *abstime, int private)
+__lll_clocklock_wait (int *futex, clockid_t clockid,
+		      const struct timespec *abstime, int private)
 {
   /* Reject invalid timeouts.  */
   if (abstime->tv_nsec < 0 || abstime->tv_nsec >= 1000000000)
@@ -33,15 +34,15 @@ __lll_timedlock_wait (int *futex, const struct timespec *abstime, int private)
   /* Try locking.  */
   while (atomic_exchange_acq (futex, 2) != 0)
     {
-      struct timeval tv;
+      struct timespec ts;
 
       /* Get the current time.  */
-      (void) __gettimeofday (&tv, NULL);
+      (void) __clock_gettime (clockid, &ts);
 
       /* Compute relative timeout.  */
       struct timespec rt;
-      rt.tv_sec = abstime->tv_sec - tv.tv_sec;
-      rt.tv_nsec = abstime->tv_nsec - tv.tv_usec * 1000;
+      rt.tv_sec = abstime->tv_sec - ts.tv_sec;
+      rt.tv_nsec = abstime->tv_nsec - ts.tv_nsec;
       if (rt.tv_nsec < 0)
         {
           rt.tv_nsec += 1000000000;
diff --git a/nptl/pthread_mutex_timedlock.c b/nptl/pthread_mutex_timedlock.c
index d4d11cc..10a9989 100644
--- a/nptl/pthread_mutex_timedlock.c
+++ b/nptl/pthread_mutex_timedlock.c
@@ -28,8 +28,9 @@
 
 #include <stap-probe.h>
 
-#ifndef lll_timedlock_elision
-#define lll_timedlock_elision(a,dummy,b,c) lll_timedlock(a, b, c)
+#ifndef lll_clocklock_elision
+#define lll_clocklock_elision(futex, adapt_count, clockid, abstime, private) \
+  lll_clocklock (futex, clockid, abstime, private)
 #endif
 
 #ifndef lll_trylock_elision
@@ -75,7 +76,7 @@ __pthread_mutex_timedlock (pthread_mutex_t *mutex,
 	}
 
       /* We have to get the mutex.  */
-      result = lll_timedlock (mutex->__data.__lock, abstime,
+      result = lll_clocklock (mutex->__data.__lock, CLOCK_REALTIME, abstime,
 			      PTHREAD_MUTEX_PSHARED (mutex));
 
       if (result != 0)
@@ -98,16 +99,16 @@ __pthread_mutex_timedlock (pthread_mutex_t *mutex,
       FORCE_ELISION (mutex, goto elision);
     simple:
       /* Normal mutex.  */
-      result = lll_timedlock (mutex->__data.__lock, abstime,
+      result = lll_clocklock (mutex->__data.__lock, CLOCK_REALTIME, abstime,
 			      PTHREAD_MUTEX_PSHARED (mutex));
       break;
 
     case PTHREAD_MUTEX_TIMED_ELISION_NP:
     elision: __attribute__((unused))
       /* Don't record ownership */
-      return lll_timedlock_elision (mutex->__data.__lock,
+      return lll_clocklock_elision (mutex->__data.__lock,
 				    mutex->__data.__spins,
-				    abstime,
+				    CLOCK_REALTIME, abstime,
 				    PTHREAD_MUTEX_PSHARED (mutex));
 
 
@@ -124,7 +125,8 @@ __pthread_mutex_timedlock (pthread_mutex_t *mutex,
 	    {
 	      if (cnt++ >= max_cnt)
 		{
-		  result = lll_timedlock (mutex->__data.__lock, abstime,
+		  result = lll_clocklock (mutex->__data.__lock,
+					  CLOCK_REALTIME, abstime,
 					  PTHREAD_MUTEX_PSHARED (mutex));
 		  break;
 		}
diff --git a/sysdeps/nptl/lowlevellock.h b/sysdeps/nptl/lowlevellock.h
index e905829..deec184 100644
--- a/sysdeps/nptl/lowlevellock.h
+++ b/sysdeps/nptl/lowlevellock.h
@@ -121,24 +121,25 @@ extern void __lll_lock_wait (int *futex, int private) attribute_hidden;
 #define lll_cond_lock(futex, private) __lll_cond_lock (&(futex), private)
 
 
-extern int __lll_timedlock_wait (int *futex, const struct timespec *,
+extern int __lll_clocklock_wait (int *futex, clockid_t,
+				 const struct timespec *,
 				 int private) attribute_hidden;
 
 
 /* As __lll_lock, but with a timeout.  If the timeout occurs then return
    ETIMEDOUT.  If ABSTIME is invalid, return EINVAL.  */
-#define __lll_timedlock(futex, abstime, private)                \
+#define __lll_clocklock(futex, clockid, abstime, private)       \
   ({                                                            \
     int *__futex = (futex);                                     \
     int __val = 0;                                              \
                                                                 \
     if (__glibc_unlikely                                        \
         (atomic_compare_and_exchange_bool_acq (__futex, 1, 0))) \
-      __val = __lll_timedlock_wait (__futex, abstime, private); \
+      __val = __lll_clocklock_wait (__futex, clockid, abstime, private); \
     __val;                                                      \
   })
-#define lll_timedlock(futex, abstime, private)  \
-  __lll_timedlock (&(futex), abstime, private)
+#define lll_clocklock(futex, clockid, abstime, private)         \
+  __lll_clocklock (&(futex), clockid, abstime, private)
 
 
 /* This is an expression rather than a statement even though its value is
diff --git a/sysdeps/unix/sysv/linux/powerpc/elision-timed.c b/sysdeps/unix/sysv/linux/powerpc/elision-timed.c
index f65818b..739cb6e 100644
--- a/sysdeps/unix/sysv/linux/powerpc/elision-timed.c
+++ b/sysdeps/unix/sysv/linux/powerpc/elision-timed.c
@@ -20,9 +20,9 @@
 #include <elision-conf.h>
 #include "lowlevellock.h"
 
-#define __lll_lock_elision __lll_timedlock_elision
-#define EXTRAARG const struct timespec *t,
+#define __lll_lock_elision __lll_clocklock_elision
+#define EXTRAARG clockid_t clockid, const struct timespec *t,
 #undef LLL_LOCK
-#define LLL_LOCK(a, b) lll_timedlock(a, t, b)
+#define LLL_LOCK(a, b) lll_clocklock(a, clockid, t, b)
 
 #include "elision-lock.c"
diff --git a/sysdeps/unix/sysv/linux/powerpc/lowlevellock.h b/sysdeps/unix/sysv/linux/powerpc/lowlevellock.h
index 77235d7..68dda59 100644
--- a/sysdeps/unix/sysv/linux/powerpc/lowlevellock.h
+++ b/sysdeps/unix/sysv/linux/powerpc/lowlevellock.h
@@ -22,12 +22,13 @@
 #include <sysdeps/nptl/lowlevellock.h>
 
 /* Transactional lock elision definitions.  */
-extern int __lll_timedlock_elision
-  (int *futex, short *adapt_count, const struct timespec *timeout, int private)
+extern int __lll_clocklock_elision
+  (int *futex, short *adapt_count,
+   clockid_t clockid, const struct timespec *timeout, int private)
   attribute_hidden;
 
-#define lll_timedlock_elision(futex, adapt_count, timeout, private)	      \
-  __lll_timedlock_elision(&(futex), &(adapt_count), timeout, private)
+#define lll_clocklock_elision(futex, adapt_count, clockid, timeout, private) \
+  __lll_clocklock_elision(&(futex), &(adapt_count), clockid, timeout, private)
 
 extern int __lll_lock_elision (int *futex, short *adapt_count, int private)
   attribute_hidden;
diff --git a/sysdeps/unix/sysv/linux/s390/elision-timed.c b/sysdeps/unix/sysv/linux/s390/elision-timed.c
index f7a90fa..2563176 100644
--- a/sysdeps/unix/sysv/linux/s390/elision-timed.c
+++ b/sysdeps/unix/sysv/linux/s390/elision-timed.c
@@ -19,8 +19,8 @@
 #include <time.h>
 #include <elision-conf.h>
 #include <lowlevellock.h>
-#define __lll_lock_elision __lll_timedlock_elision
-#define EXTRAARG const struct timespec *t,
+#define __lll_lock_elision __lll_clocklock_elision
+#define EXTRAARG clockid_t clockid, const struct timespec *t,
 #undef LLL_LOCK
-#define LLL_LOCK(a, b) lll_timedlock(a, t, b)
+#define LLL_LOCK(a, b) lll_clocklock(a, clockid, t, b)
 #include "elision-lock.c"
diff --git a/sysdeps/unix/sysv/linux/s390/lowlevellock.h b/sysdeps/unix/sysv/linux/s390/lowlevellock.h
index 77e7580..af4b614 100644
--- a/sysdeps/unix/sysv/linux/s390/lowlevellock.h
+++ b/sysdeps/unix/sysv/linux/s390/lowlevellock.h
@@ -22,12 +22,13 @@
 #include <sysdeps/nptl/lowlevellock.h>
 
 /* Transactional lock elision definitions.  */
-extern int __lll_timedlock_elision
-  (int *futex, short *adapt_count, const struct timespec *timeout, int private)
+extern int __lll_clocklock_elision
+  (int *futex, short *adapt_count,
+   clockid_t clockid, const struct timespec *timeout, int private)
   attribute_hidden;
 
-#  define lll_timedlock_elision(futex, adapt_count, timeout, private)	\
-  __lll_timedlock_elision(&(futex), &(adapt_count), timeout, private)
+#  define lll_clocklock_elision(futex, adapt_count, clockid, timeout, private) \
+  __lll_clocklock_elision(&(futex), &(adapt_count), clockid, timeout, private)
 
 extern int __lll_lock_elision (int *futex, short *adapt_count, int private)
   attribute_hidden;
diff --git a/sysdeps/unix/sysv/linux/x86/elision-timed.c b/sysdeps/unix/sysv/linux/x86/elision-timed.c
index 9abc6ec..2c5073b 100644
--- a/sysdeps/unix/sysv/linux/x86/elision-timed.c
+++ b/sysdeps/unix/sysv/linux/x86/elision-timed.c
@@ -19,8 +19,8 @@
 #include <time.h>
 #include <elision-conf.h>
 #include "lowlevellock.h"
-#define __lll_lock_elision __lll_timedlock_elision
-#define EXTRAARG const struct timespec *t,
+#define __lll_lock_elision __lll_clocklock_elision
+#define EXTRAARG clockid_t clockid, const struct timespec *t,
 #undef LLL_LOCK
-#define LLL_LOCK(a, b) lll_timedlock(a, t, b)
+#define LLL_LOCK(a, b) lll_clocklock (a, clockid, t, b)
 #include "elision-lock.c"
diff --git a/sysdeps/unix/sysv/linux/x86/lowlevellock.h b/sysdeps/unix/sysv/linux/x86/lowlevellock.h
index 8a78dcf..e6c59ea 100644
--- a/sysdeps/unix/sysv/linux/x86/lowlevellock.h
+++ b/sysdeps/unix/sysv/linux/x86/lowlevellock.h
@@ -82,12 +82,13 @@ __lll_cas_lock (int *futex)
        __lll_unlock (&(lock), private);					     \
    }))
 
-extern int __lll_timedlock_elision (int *futex, short *adapt_count,
-					 const struct timespec *timeout,
-					 int private) attribute_hidden;
+extern int __lll_clocklock_elision (int *futex, short *adapt_count,
+                                    clockid_t clockid,
+				    const struct timespec *timeout,
+				    int private) attribute_hidden;
 
-#define lll_timedlock_elision(futex, adapt_count, timeout, private)	\
-  __lll_timedlock_elision(&(futex), &(adapt_count), timeout, private)
+#define lll_clocklock_elision(futex, adapt_count, clockid, timeout, private) \
+  __lll_clocklock_elision (&(futex), &(adapt_count), clockid, timeout, private)
 
 extern int __lll_lock_elision (int *futex, short *adapt_count, int private)
   attribute_hidden;