diff --git a/ChangeLog b/ChangeLog
index aece032..cbac0c4 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,111 @@
+2019-06-29  Vincent Chen  <vincentc@andestech.com>
+
+	* scripts/build-many-glibcs.py: Add nds32 targets.
+	* sysdeps/nds32/Implies: New file.
+	* sysdeps/nds32/Makefile: Likewise.
+	* sysdeps/nds32/__longjmp.S: Likewise.
+	* sysdeps/nds32/atomic-machine.h: Likewise.
+	* sysdeps/nds32/bits/endian.h: Likewise.
+	* sysdeps/nds32/bits/fenv.h: Likewise.
+	* sysdeps/nds32/bits/link.h: Likewise.
+	* sysdeps/nds32/bits/setjmp.h: Likewise.
+	* sysdeps/nds32/bsd-_setjmp.S: Likewise.
+	* sysdeps/nds32/bsd-setjmp.S: Likewise.
+	* sysdeps/nds32/configure: Likewise.
+	* sysdeps/nds32/configure.ac: Likewise.
+	* sysdeps/nds32/dl-machine.h: Likewise.
+	* sysdeps/nds32/dl-sysdep.h: Likewise.
+	* sysdeps/nds32/dl-tls.h: Likewise.
+	* sysdeps/nds32/dl-tlsdesc.S: Likewise.
+	* sysdeps/nds32/dl-tlsdesc.h: Likewise.
+	* sysdeps/nds32/dl-trampoline.S: Likewise.
+	* sysdeps/nds32/gccframe.h: Likewise.
+	* sysdeps/nds32/jmpbuf-offsets.h: Likewise.
+	* sysdeps/nds32/jmpbuf-unwind.h: Likewise.
+	* sysdeps/nds32/ldsodefs.h: Likewise.
+	* sysdeps/nds32/linkmap.h: Likewise.
+	* sysdeps/nds32/machine-gmon.h: Likewise.
+	* sysdeps/nds32/memcpy.S: Likewise.
+	* sysdeps/nds32/memset.S: Likewise.
+	* sysdeps/nds32/memusage.h: Likewise.
+	* sysdeps/nds32/nofpu/Implies: Likewise.
+	* sysdeps/nds32/nofpu/libm-test-ulps: Likewise.
+	* sysdeps/nds32/nofpu/libm-test-ulps-name: Likewise.
+	* sysdeps/nds32/nptl/Makefile: Likewise.
+	* sysdeps/nds32/nptl/bits/pthreadtypes-arch.h: Likewise.
+	* sysdeps/nds32/nptl/bits/semaphore.h: Likewise.
+	* sysdeps/nds32/nptl/pthread-offsets.h: Likewise.
+	* sysdeps/nds32/nptl/pthreaddef.h: Likewise.
+	* sysdeps/nds32/nptl/tcb-offsets.sym: Likewise.
+	* sysdeps/nds32/nptl/tls.h: Likewise.
+	* sysdeps/nds32/preconfigure: Likewise.
+	* sysdeps/nds32/setjmp.S: Likewise.
+	* sysdeps/nds32/sfp-machine.h: Likewise.
+	* sysdeps/nds32/sotruss-lib.c: Likewise.
+	* sysdeps/nds32/stackinfo.h: Likewise.
+	* sysdeps/nds32/start.S: Likewise.
+	* sysdeps/nds32/strcmp.S: Likewise.
+	* sysdeps/nds32/strcpy.S: Likewise.
+	* sysdeps/nds32/sysdep.h: Likewise.
+	* sysdeps/nds32/tininess.h: Likewise.
+	* sysdeps/nds32/tls-macros.h: Likewise.
+	* sysdeps/nds32/tlsdesc.c: Likewise.
+	* sysdeps/nds32/tlsdesc.sym: Likewise.
+	* sysdeps/nds32/tst-audit.h: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/Implies: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/Makefile: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/Versions: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/bits/environments.h: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/bits/procfs.h: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/bits/shmlba.h: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/bits/stat.h: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/bits/statfs.h: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/bits/typesizes.h: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/c++-types.data: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/clone.S: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/configure: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/configure.ac: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/dl-static.c: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/getcontext.S: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/init-first.c: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/ipc_priv.h: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/jmp_buf-macros.h: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/kernel-features.h: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/kernel_stat.h: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/ld.abilist: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/ldconfig.h: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/ldsodefs.h: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/libBrokenLocale.abilist: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/libanl.abilist: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/libc-vdso.h: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/libc.abilist: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/libcrypt.abilist: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/libdl.abilist: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/libm.abilist: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/libpthread.abilist: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/libresolv.abilist: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/librt.abilist: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/libthread_db.abilist: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/libutil.abilist: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/localplt.data: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/makecontext.c: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/profil-counter.h: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/pt-vfork.S: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/setcontext.S: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/shlib-versions: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/sigcontextinfo.h: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/swapcontext.S: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/sys/cachectl.h: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/sys/ucontext.h: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/sys/user.h: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/syscall.c: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/syscalls.list: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/sysctl.mk: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/sysdep.c: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/sysdep.h: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/ucontext_i.sym: Likewise.
+	* sysdeps/unix/sysv/linux/nds32/vfork.S: Likewise.
+
 2019-06-28  Wilco Dijkstra  <wdijkstr@arm.com>
 
 	* benchtests/bench-math-inlines.c: Increase iterations.
diff --git a/NEWS b/NEWS
index 6c7de10..e585f94 100644
--- a/NEWS
+++ b/NEWS
@@ -40,6 +40,10 @@ Major new features:
   FUNCTION-NAME, version SYMBOL-VERSION not defined in file DSO-NAME with
   link time reference, is gone.
 
+* Support for the  nds32 ABI 2 running on Linux has been add.  This port
+  requires at least binutils-2.32, gcc-9.0.0, and linux-4.17.  only one
+  ABI, nds32 ABI 2 soft-fp, is supported.
+
 Deprecated and removed features, and other changes affecting compatibility:
 
 * The copy_file_range function fails with ENOSYS if the kernel does not
diff --git a/README b/README
index eb9b0b3..2f492f9 100644
--- a/README
+++ b/README
@@ -34,6 +34,7 @@ The GNU C Library supports these configurations for using Linux kernels:
 	microblaze*-*-linux-gnu
 	mips-*-linux-gnu
 	mips64-*-linux-gnu
+	nds32le-linux-gnu
 	powerpc-*-linux-gnu	Hardware or software floating point, BE only.
 	powerpc64*-*-linux-gnu	Big-endian and little-endian.
 	s390-*-linux-gnu